#!/bin/sh

### BEGIN INIT INFO
# Provides:          sc_debug_test_reboot
# Required-Start:    $remote_fs $ALL
# Should-Start:      $null
# Required-Stop:     $null
# Should-Stop:       $null
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: SmartClient debugging test script
# Description:       performs some tests 
#	and reboots the system on test failures.
#	It can be used for debugging purposes,
#	if the system is not always coming up in the correct state.
#	Normally, it should be deactivated. 
#	It is only intended for debugging purposes.
### END INIT INFO

NAME="SmartClient system state check (debugging)"
LOGFILE="/var/log/smartclient/sc_debug_test_reboot"
TIMEOUT=20


# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
#FOO_BIN=/usr/sbin/FOO
#test -x $FOO_BIN || { echo "$FOO_BIN not installed"; 
#	if [ "$1" = "stop" ]; then exit 0;
#	else exit 5; fi; }

# Check for existence of needed config file and read it
#FOO_CONFIG=/etc/sysconfig/FOO
#test -r $FOO_CONFIG || { echo "$FOO_CONFIG not existing";
#	if [ "$1" = "stop" ]; then exit 0;
#	else exit 6; fi; }

# Read config	
#. $FOO_CONFIG

# Source LSB init functions
# providing start_daemon, killproc, pidofproc, 
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

check()
{
    DIR=/misc/dat/vorlagen/
    MESSAGE="accessing directory $DIR"
    test -d $DIR
    return $?
}

case "$1" in
    start)
        echo -n "Starting $NAME "

        check
        rc_status

        chvt 1
        DATE=`date "+%F %T"`

        if rc_status; then
            rc_status -v
            echo "$DATE $MESSAGE: okay" >> $LOGFILE
            echo "rebooting in ${TIMEOUT}s"
            sleep ${TIMEOUT}
            reboot
        else
            echo "$DATE $MESSAGE: failed" >> $LOGFILE
        fi
            
        rc_status -v
        ;;
    stop)
        ;;
    restart)
        ## Stop the service and regardless of whether it was
        ## running or not, start it again.
        $0 stop
        $0 start

        # Remember status and be quiet
        rc_status
        ;;
    reload)
        echo -n "Reload $NAME  "
        # it does not support reload:
        rc_failed 3
        rc_status -v
        ;;
    status)
        echo -n "Checking for $NAME "
        ## Check status with checkproc(8), if process is running
        ## checkproc will return with exit status 0.

        # Return value is slightly different for the status command:
        # 0 - service up and running
        # 1 - service dead, but /var/run/  pid  file exists
        # 2 - service dead, but /var/lock/ lock file exists
        # 3 - service not running (unused)
        # 4 - service status unknown :-(
        # 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)

        # NOTE: checkproc returns LSB compliant status values.
        #/sbin/checkproc $FOO_BIN
        # NOTE: rc_status knows that we called this init script with
        # "status" option and adapts its messages accordingly.
        check
        rc_status -v
        ;;
    *)
        echo "Usage: $0 {start|stop|status|restart}"
        exit 1
        ;;
esac
rc_exit
